/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2008 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
#include <fstream>
#include <algorithm>
#include <iterator>
#include "toppers/io.hpp"
#include "toppers/diagnostics.hpp"
#include <boost/format.hpp>

namespace toppers
{

  void read( std::string const& filename, std::string& buf, std::ios_base::openmode omode )
  {
    std::ifstream ifs( filename.c_str(), std::ios_base::in | omode );
    if ( !ifs.is_open() )
    {
      throw io_error( str( boost::format( _( "cannot open file `%1%\'" ) ) % filename ) );
    }
    std::string t;
    char c;
    while ( ifs.get( c ) )
    {
      t.push_back( c );
    }
    if ( ifs.bad() )
    {
      throw io_error( _( "I/O error" ) );
    }
    buf.swap( t );
  }

  void write( std::string const& filename, std::string const& buf, std::ios_base::openmode omode )
  {
    std::ofstream ofs( filename.c_str(), std::ios_base::out | omode );
    if ( !ofs.is_open() )
    {
      throw io_error( str( boost::format( _( "cannot open file `%1%\'" ) ) % filename ) );
    }
    std::copy( buf.begin(), buf.end(), std::ostream_iterator< char >( ofs ) );
    if ( ofs.bad() )
    {
      throw io_error( _( "I/O error" ) );
    }
  }

}
